/****************************************/
/* MES/Copyleft Yukio Mituiwa,2005	*/
/*					*/
/*  2005/2/14 first release		*/
/*					*/
/****************************************/
#include <string.h>
#include "mes.h"
#include "elftype.h"
#include "elfval.h"

int elf_info(int id, int fd, int filesize, int *start, int *size, int *stack, int *got, int *gotsiz) {
	ElfHdr	*Header;
	ElfPhdr	*Program;
	ElfShdr	*Section;
	char	*buffer;
	int	i, stroff, secname;
	int	strindex, pgmoff, seccnt, secoff, pgmcnt;

	buffer = __malloc(SuperTask, filesize); 
	if(buffer == 0) return -1;
	__read(id, fd, buffer, filesize);
	if(memcmp(buffer, "\177ELF", 4) != 0) {
		__free(SuperTask, buffer);
		return -1;
	}
	Header = (ElfHdr*)buffer;
	pgmoff = Header->e_phoff;
	secoff = Header->e_shoff;
	pgmcnt = Header->e_phnum;
	seccnt = Header->e_shnum;
	Program = (ElfPhdr*)&buffer[pgmoff];
	Section = (ElfShdr*)&buffer[secoff];
	strindex = Header->e_shstrndx;
	*start = Header->e_entry;
	*size = Program[pgmcnt - 1].p_memsz + Program[pgmcnt - 1].p_paddr;
	*got = *gotsiz = 0;
	stroff = Section[strindex].sh_offset;
	for(i = 0;i < seccnt;i++) {
		secname = Section[i].sh_name;
		if(strcmp(&buffer[stroff + secname], ".stack") == 0) {
			*stack = Section[i].sh_addr;
		}
		if(strcmp(&buffer[stroff + secname], ".got") == 0) {
			*got = Section[i].sh_addr;
			*gotsiz = Section[i].sh_size;
		}
	}
	__free(SuperTask, buffer);
	return 0;
}

int elf_load(int id, int fd, int filesize, char *pgm) {
	ElfHdr	*Header;
	ElfPhdr	*Program;
	ElfShdr	*Section;
	char	*buffer;
	int	i, memaddr, fileoff, secsize;
	int	pgmoff, secoff, pgmcnt;

	buffer = __malloc(SuperTask, filesize);
	if(buffer == 0) return -1;
	__read(id, fd, buffer, filesize);
	Header = (ElfHdr*)buffer;
	pgmoff = Header->e_phoff;
	secoff = Header->e_shoff;
	pgmcnt = Header->e_phnum;
	Program = (ElfPhdr*)&buffer[pgmoff];
	Section = (ElfShdr*)&buffer[secoff];
	for(i = 0;i < pgmcnt;i++) {
		fileoff = Program[i].p_offset;
		memaddr = Program[i].p_paddr;
		secsize = Program[i].p_filesz;
		memcpy(&pgm[memaddr], &buffer[fileoff], secsize);
	}
	__free(SuperTask, buffer);
	return 0;
}
