typedef struct {
	int	length;
	char	name[12];
	unsigned char	attr;
} DirEnt;

#define OptRead 1
#define OptWrite 2
#define OptRemove 3
#define OptAppend 4

struct sockaddr {
	unsigned int sin_addr;
	unsigned short sin_port;
};

#if defined(__H8300H__) || defined(__sh3__)
  typedef volatile unsigned char IOREG;
#endif
#if defined(__sh2__)
  typedef volatile unsigned short IOREG;
#endif

typedef struct {
	int (*open_dev)(int, int);
	int (*close_dev)(int);
	int (*write_dev)(int, char*, int);
	int (*read_dev)(int, char*, int);
	int (*seek_dev)(int, int);
	int (*ioctl_dev)(int, int, int);
	void (*poll_dev)();
	char name[8];
} Functions;

#if defined(__H8300H__)
  #define WAITCONST 1
#endif
#if defined(__sh2__) || defined(__arm__)
  #define WAITCONST 12
#endif
#if defined(__sh3__)
  #define WAITCONST 32
#endif

#define SuperTask 1

#define USBNUM 8
#define SLNUM 2

#define SECSIZ 512

#define IPADDR(a,b,c,d) (unsigned int)a*0x1000000+b*0x10000+c*0x100+d
#define NOWEP 0
#define WEP64 1
#define WEP128 2
#define stderr 2

struct process {
	int address;
	char *cwd;
	char **argv;
	char flag;
	int stack;
	int pc;
	int tcb;
};

#define PS_WAIT 0x01

struct _packet{
	volatile struct _packet *next;
	int	stamp;
	char	data[4];
};
typedef volatile struct _packet Packet;

struct _packet2{
	volatile struct _packet2 *next;
	int	stamp, size, seq, retries;
	char	data[4];
};
typedef volatile struct _packet2 Packet2;

struct wi_usb_ident {
	unsigned short	vendor;
	unsigned short	product;
	char		*product_name;
};

#define	MALLOC_IP	0x4001
#define	MALLOC_WI	0x4002
#define	MALLOC_TCP	0x4003
#define	MALLOC_UDP	0x4004
#define	MALLOC_FAT	0x4005

#define	REGIST_STRING	1
#define	REGIST_DATA	2

#define USB_NO_ERROR	0
#define USB_WRITE_ERROR	1
#define USB_DEV_DOWN	2

#define DEV_INFO 0x01
#define GET_MAC 0x02
#define SET_HANDLE 0x03
#define HANDLE_ARG 0x04
#define MAXPACKET 0x05
#define DISK_CACHE 0x06
#define MEDIA_SIZE 0x07
#define DEV_RESET 0x08
#define DEV_INTERVAL 0x09
#define DEV_START 0x0a
#define DEV_STOP 0x0b
#define DEV_FLUSH 0x0c
#define DEV_BLOCK 0x0d
#define READ_BURST 0x0e
#define SCI_FREQ 0x101
#define SCI_SPEED 0x102
#define SCI_POLL 0x103
#define SCI_CONTINUE 0x104
#define WI_GETBSSID 0x201
#define WI_SETWEPKEY 0x202
#define WI_GETWEPKEY 0x203
#define WI_SETWEP64 0x204
#define WI_SETWEP128 0x205
#define WI_WEPON 0x206
#define WI_SETSSID 0x207
#define WI_GETSSID 0x208
#define WI_PMGTON 0x209
#define WI_SETWPA 0x20a
#define WI_USBDOWN 0x20b
#define MMC_CSD 0x301
#define MMC_CID 0x302
#define USB_EPSIZE 0x401
#define USB_INFO 0x402
#define USB_SETCONF 0x403
#define USB_SETUP 0x404
#define USB_RESET 0x405
#define USB_GETSTATUS 0x406
#define USB_TIMEOUT 0x407
#define USB_INTERRUPT 0x408
#define USB_VENDOR 0x409
#define USB_PRODUCT 0x40a
#define USB_SET_EPSIZE 0x40b
#define USB_INTR_EP 0x40c
#define USB_FAST_RETRY 0x40d
#define USB_WRITE_TIMEOUT 0x40e
#define USB_ERROR_STATUS 0x40f
#define LCD_CLEAR 0x501
#define LCD_SETFONT 0x502


#define HW_CONFIG_TURBO 0x01

