#define DEVICE_READY	0x00
#define READ_CAPACITY	0x25
#define READ_FORM_CAPA	0x23
#define READ_SECTOR	0x28
#define WRITE_SECTOR	0x2a
#define WRITE_VERIFY	0x2e
#define REQUEST_SENSE	0x03
#define INQUIRY		0x12
#define MODE_SENSE	0x1a

typedef struct {
	unsigned char	code __attribute__((packed));
	unsigned char	lun __attribute__((packed));
	unsigned int	lba __attribute__((packed));
	unsigned char	nop1 __attribute__((packed));
	unsigned short	size __attribute__((packed));
	unsigned char	nop2 __attribute__((packed));
} UFI;

typedef struct {
	unsigned char	code __attribute__((packed));
	unsigned char	nop1 __attribute__((packed));
	unsigned char	pagecode __attribute__((packed));
	unsigned char	nop2 __attribute__((packed));
	unsigned char	size __attribute__((packed));
	unsigned char	nop3 __attribute__((packed));
} ReqSense;

typedef struct {
	unsigned char	header[8] __attribute__((packed));
	unsigned int	rcvlen __attribute__((packed));
	unsigned char	flag __attribute__((packed));
	unsigned char	lun __attribute__((packed));
	unsigned char	sendlen __attribute__((packed));
	union {
		UFI		ufi __attribute__((packed));
		ReqSense	reqsense __attribute__((packed));
	} cb;	
	unsigned short	nop1 __attribute__((packed));
	unsigned int	nop2 __attribute__((packed));
} CBW;

typedef struct {
	unsigned char	header[8] __attribute__((packed));
	unsigned int	residue __attribute__((packed));
	unsigned char	status __attribute__((packed));
} CSW;
