/****************************************/
/* MES/Copyleft Yukio Mituiwa,2005	*/
/*					*/
/*  2005/6/1 first release		*/
/*					*/
/****************************************/
#include <string.h>
#include "mes.h"

typedef struct {
	unsigned int	key;
	int		size;
	char		*ptr;
} ShmInfo;

#define SHM_NUM	 256
static ShmInfo *sharemem;

void shm_init(void) {
	int	i;

	sharemem = (ShmInfo *)__malloc(SuperTask, sizeof(ShmInfo) * SHM_NUM);
	for(i = 0;i < SHM_NUM;i++) {
		sharemem[i].size = 0;
		sharemem[i].key = 0;
		sharemem[i].ptr = 0;
	}
}

int shm_get(unsigned int key, int size) {
	int	i;

	for(i = 0;i < SHM_NUM;i++) {
		if(sharemem[i].key == key) return i;
	}
	for(i = 0;i < SHM_NUM;i++) {
		if(sharemem[i].size == 0) {
			sharemem[i].key = key;
			sharemem[i].size = size;
			return i;
		}
	}
	return -1;
}

char* shm_at(int id) {
	char *ptr;

	if(id >= SHM_NUM ||
	   sharemem[id].size == 0 ||
	   sharemem[id].key == 0) return 0;
	if(sharemem[id].ptr == 0) {
		ptr = __malloc(SuperTask, sharemem[id].size);
		if(ptr == 0) return 0;
		sharemem[id].ptr = ptr;
	}
	return sharemem[id].ptr;
}

int shm_dt(int id) {
	if(id >= SHM_NUM ||
	   sharemem[id].size == 0 ||
	   sharemem[id].key == 0 ||
	   sharemem[id].ptr == 0) return -1;
	__free(SuperTask, sharemem[id].ptr);
	sharemem[id].size = 0;
	sharemem[id].key = 0;
	sharemem[id].ptr = 0;
	return 0;
}
